#include "TexAnimeEffect.h"

TexAnimeEffectModel::TexAnimeEffectModel(void)
{
	setRect.readPNG("effect/locus.png");
	setEffect(setRect, 512, 512, 5, 5, 25);
}

TexAnimeEffectModel::~TexAnimeEffectModel(void)
{
}

void TexAnimeEffectModel::setEffect(fk_RectTexture arg_rect, double arg_X_Max, double arg_Y_Max,
									int arg_split_X, int arg_split_Y, int arg_stepMax) 
{
	rect = arg_rect;
	rect.setTextureMode(FK_TEX_REPLACE);
	rect.setTexRendMode(FK_TEX_REND_SMOOTH);
	rect.setTextureSize(100.0, 100.0);
	this->setShape(&rect);

	effect_X_Max = arg_X_Max;
	effect_Y_Max = arg_Y_Max;
	split_X = arg_split_X;
	split_Y = arg_split_Y;
	effect_X = effect_X_Max/(double)split_X;
	effect_Y = effect_Y_Max/(double)split_Y;
	stepMax = arg_stepMax;
	setLR = 1;

	step = 0;
}

void TexAnimeEffectModel::setSize(double w, double h)
{
	rect.setTextureSize(w, h);
}

void TexAnimeEffectModel::update(fk_Model *ref_camera)
{
	/*
	fk_TexCoord(0.0, 1.0);
	fk_TexCoord(0.2, 0.8);
	fk_TexCoord(0.2, 1.0);
	fk_TexCoord(0.4, 0.8);
	fk_TexCoord(0.4, 1.0);
	fk_TexCoord(0.6, 0.8);
	fk_TexCoord(0.6, 1.0);
	fk_TexCoord(0.8, 0.8);
	fk_TexCoord(0.8, 1.0);
	fk_TexCoord(1.0, 0.8);
	*/
	rect.setTextureCoord(((double)(step%split_X)*effect_X)/effect_X_Max, (effect_Y_Max-((double)(1+(step/split_X))*effect_Y))/effect_Y_Max,
		((double)(1+(step%split_X))*effect_X)/effect_X_Max, (effect_Y_Max-((double)(step/split_X)*effect_Y))/effect_Y_Max);
	/*
	rect.setTextureCoord((double)(step%5)*0.2, 1.0-(double)(step/5)*0.2,
							(double)((step%5)+1)*0.2, 1.0-(double)((step/5)+1)*0.2);

	printf("%d: (%f, %f) - (%f, %f)\n", step, (double)(step%5)*0.2, 1.0-(double)(step/5)*0.2,
							(double)((step%5)+1)*0.2, 1.0-(double)((step/5)+1)*0.2);
	*/

	step++;
	if(step >= stepMax) step = 0;

	this->glFocus(ref_camera->getInhPosition());
	this->loFocus(0.0, 0.0, 1.0);

	return;
}

void TexAnimeEffectModel::preShader()
{
	glBlendFunc(GL_ONE, GL_ONE);
	glDepthMask(GL_FALSE);
	glDisable(GL_DEPTH_TEST);
}

void TexAnimeEffectModel::postShader()
{
	glEnable(GL_DEPTH_TEST);
	glDepthMask(GL_TRUE);
	glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
}
