#include <GL/glew.h>
#include <FK/FK.h>
#include "FKUT/TrackBall.h"
#include "FKUT/GuideObject.h"
#include "GLSLModel.h"

#include "VolumeLineModel.h"
#include "TexAnimeEffect.h"
#include "BlurEffect.h"


// Window̏ƓOpenGLg@\(GLEW)Lɂ
class MyWindow : public fk_Window {
public:
	MyWindow(int x = 0, int y = 0, int w = 300, int h = 300, std::string name = "")
		: fk_Window(x, y, w, h, name)
	{
	};

	~MyWindow()
	{
	};

	void preInit(void)
	{
#ifdef WIN32
		// GLEW ̏
		GLenum err = glewInit();
		if (err != GLEW_OK) {
			fprintf(stderr, "Error: %s\n", glewGetErrorString(err));
			exit(1);
		}
#endif
		return;
	};

};

int main(int argc, char *argv[])
{
	// IɃJgtH_exeƓʒuɂ
	fk_System::setcwd();

	Fl_Window		mainWindow(960, 540, "FK TEST");
	fk_Model		camera, lightModel;
	fk_Light		light;
	fk_Scene		scene;
	MyWindow		window(0, 0, 960, 540);	// Ŏd񂾃EBhEɂւ

	fkut_GuideObject	guide;
	fk_TrackBall		tb(&window, &camera);

	fk_IFSTexture	ifsShape;
	fk_Sphere		sph(8, 7.0);

	// `̗pӂ͂ʂ肾Afd񂾂̂ɂւ
	GLSLModel		modelDef, ifsModelDef;
	GLSLModel		sphShockModel;

	// {[CTv
	fk_VolumeLineModel	vLine;
	fk_Image			img;

	// eNX`Aj[VTv
	TexAnimeEffectModel	texAnime;

	// u[Tv
	BlurEffect	blur;
	fk_Block	block;
	fk_Model	blockModel;

	mainWindow.end();
	fk_InitMaterial();
	// R\[ȊO̕ʃEBhEɃG[o
	fk_SetErrorMode(FK_ERR_BROWSER_INTERACTIVE);

	// Ɩ̐ݒ
	lightModel.setShape(&light);
	lightModel.setMaterial(White);
	lightModel.getMaterial()->setAmbDiff(1.0f, 1.0f, 1.0f);
	lightModel.getMaterial()->setSpecular(1.0f, 1.0f, 1.0f);
	lightModel.glMoveTo(0.0, 0.0, 0.0);
	lightModel.glFocus(-1.0, -1.0, -1.0);

	// f̓ǂݍ
	if(!ifsShape.readBMP("mqo/00tex_master.BMP")) fl_alert("tex load err");
	if(!ifsShape.readMQOFile("mqo/meka.mqo", "body01")) fl_alert("ifs load err");
	ifsShape.setTexRendMode(FK_TEX_REND_SMOOTH);

	// effBXvCXgɓo^
	scene.setBlendStatus(true);
	scene.setBGColor(0.5f, 0.5f, 0.5f);
	scene.entryCamera(&camera);
	scene.entryModel(&lightModel);
	guide.entryScene(&scene);

	// EBhEփfBXvCXgo^
	window.setScene(&scene);

	// _̈ʒuƎpݒ
	camera.glMoveTo(0.0, 0.0, 100.0);
	camera.glFocus(0.0, 0.0, 0.0);
	camera.glUpvec(0.0, 1.0, 0.0);

	mainWindow.show();
	window.show();
	Fl::check();
	// ̎_GLSL֘A̖߂ւ̂ŁA
	// ܂łɃVF[_gf̃Gg[`Ȃ悤ɂ

	modelDef.setShape(&sph);
	modelDef.setMaterial(Yellow);
	modelDef.setSmoothMode(true);
	modelDef.glMoveTo(-20.0, 0.0, 0.0);
	// ǂݍ݂VF[_t@Cw
	modelDef.initShader("shader/model_vp.glsl", "shader/model_fp.glsl");
	scene.entryModel(&modelDef);

	ifsModelDef.setShape(&ifsShape);
	ifsModelDef.setMaterial(White);
	ifsModelDef.setSmoothMode(false);
	ifsModelDef.glMoveTo(20.0, 0.0, 0.0);
	// ǂݍ݂VF[_t@Cw
	ifsModelDef.initShader("shader/model_vp.glsl", "shader/modelTex_fp.glsl");
	ifsModelDef.setTexUse(true);	// eNX`g[h
	scene.entryModel(&ifsModelDef);

	sphShockModel.setShape(&sph);
	sphShockModel.setSmoothMode(true);
	sphShockModel.setScale(0.01);
	// ǂݍ݂VF[_t@Cw
	sphShockModel.initShader("shader/model_vp.glsl", "shader/shockSph_fp.glsl");
	sphShockModel.setSatUse(true);	// ق킩uhg[h
	scene.entryModel(&sphShockModel);


	// windowshowĂ炶ȂcgInit()Ȃ
	vLine.cgInit();
	if(!img.readBMP("effect/1d_cyan.bmp")) fl_alert("readBMP() err!");
	vLine.setImage(&img);
	vLine.pushLine(fk_Vector(-10.0, 0.0, 0.0), fk_Vector(10.0, 0.0, 0.0), 10.0);
	vLine.pushLine(fk_Vector(-10.0, 0.0, -10.0), fk_Vector(10.0, 0.0, 10.0), 5.0);
	scene.entryModel(&vLine);

	// eNX`
	texAnime.setSize(20.0, 20.0);
	scene.entryModel(&texAnime);

	// u[̏
	block.setBlockSize(2.0, 2.0, 20.0);
	blockModel.setShape(&block);
	blockModel.setMaterial(Yellow);
	blockModel.glMoveTo(0.0, 0.0, -10.0);
	scene.entryModel(&blockModel);

	while(true) {
		if(mainWindow.visible() == 0) {
			if(Fl::wait() == 0) {
				break;
			} else {
				continue;
			}
		}

		if(window.drawWindow() == 0) break;
		if(Fl::check() == 0) break;
		if(window.winOpenStatus() == false) continue;

		lightModel.glRotateWithVec(0.0, 0.0, 0.0, fk_Y, 0.01);

		if(window.getKeyStatus(' ', false)) {
			sphShockModel.setScale(sphShockModel.getScale()+0.1);
		}
		sphShockModel.glVec(-camera.getInhVec());

		tb.update();

		texAnime.update(&camera);
		if(window.getKeyStatus('z') == true) {
			blockModel.glRotateWithVec(0.0, 0.0, 0.0, fk_Y, FK_PI/10.0);
			blur.update(&scene, &blockModel, true);
		} else {
			blur.update(&scene, &blockModel, false);
		}
	}

	return 0;
}
